Debian Bug report logs - #413661
libblkid1: leaks memory like crazy

version graph

Package: libblkid1; Maintainer for libblkid1 is LaMont Jones <lamont@debian.org>; Source for libblkid1 is src:util-linux.

Reported by: "Steinar H. Gunderson" <sgunderson@bigfoot.com>

Date: Tue, 6 Mar 2007 13:12:01 UTC

Severity: important

Tags: patch

Fixed in versions e2fsprogs/1.39+1.40-WIP-2006.11.14+dfsg-2, 1.39+1.40-WIP-2007.04.07+dfsg-1

Done: tytso@mit.edu (Theodore Y. Ts'o)

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, nfs@lists.sourceforge.net, 413429@bugs.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#413661; Package libblkid1. Full text and rfc822 format available.

Acknowledgement sent to "Steinar H. Gunderson" <sgunderson@bigfoot.com>:
New Bug report received and forwarded. Copy sent to nfs@lists.sourceforge.net, 413429@bugs.debian.org, tytso@mit.edu (Theodore Y. Ts'o). Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: "Steinar H. Gunderson" <sgunderson@bigfoot.com>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: libblkid1: leaks memory like crazy
Date: Tue, 06 Mar 2007 14:08:43 +0100
[Message part 1 (text/plain, inline)]
Package: libblkid1
Version: 1.39+1.40-WIP-2006.11.14+dfsg-1
Severity: grave
Tags: patch

(RMs: I'm unsure if this should be fixed for etch or not, given that I
do not know of anything in etch that actually uses this library enough
for it to leak. Feel free to downgrade or tag etch-ignore, of course.)

nfs-kernel-server 1.0.12 has started using libblkid, and leaks absurd
amounts of memory (in the order of several megabytes per minute).
Tracing using Omega (which is not yet in Debian, but nevertheless really
useful) tracked the leaks down to libblkid. I've attached a diff that
fixes the issues for me, and allows me to run nfs-kernel-server with
only minor leaks (which I'll take with nfs-utils upstream, as they are
not libblkid1 related).

-- System Information:
Debian Release: 4.0
  APT prefers unstable
  APT policy: (500, 'unstable'), (500, 'testing'), (1, 'experimental')
Architecture: amd64 (x86_64)
Shell:  /bin/sh linked to /bin/bash
Kernel: Linux 2.6.19
Locale: LANG=en_DK.UTF-8, LC_CTYPE=en_DK.UTF-8 (charmap=UTF-8)

Versions of packages libblkid1 depends on:
ii  libc6                       2.3.6.ds1-13 GNU C Library: Shared libraries
ii  libdevmapper1.02            2:1.02.12-1  The Linux Kernel Device Mapper use
ii  libselinux1                 1.32-3       SELinux shared libraries
ii  libsepol1                   1.14-3       Security Enhanced Linux policy lib

libblkid1 recommends no packages.

-- debconf-show failed
[libblkid-leak-fixes.diff (text/plain, attachment)]

Blocking bugs of 413429 added: 413661 Request was from Steinar H. Gunderson <sesse@debian.org> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#413661; Package libblkid1. Full text and rfc822 format available.

Acknowledgement sent to "Steinar H. Gunderson" <sgunderson@bigfoot.com>:
Extra info received and forwarded to list. Copy sent to tytso@mit.edu (Theodore Y. Ts'o). Full text and rfc822 format available.

Message #12 received at 413661@bugs.debian.org (full text, mbox):

From: "Steinar H. Gunderson" <sgunderson@bigfoot.com>
To: 413661@bugs.debian.org
Subject: Re: libblkid1: leaks memory like crazy
Date: Tue, 6 Mar 2007 16:19:43 +0100
On Tue, Mar 06, 2007 at 02:08:43PM +0100, Steinar H. Gunderson wrote:
> Only in e2fsprogs-patched/debian: BUILD-BF
> Only in e2fsprogs-patched/debian: BUILD-STD
> Only in e2fsprogs-patched/debian: comerr-dev
> Only in e2fsprogs-patched/debian: comerr-dev.postinst.debhelper

Feh, I attached the wrong patch. Disregarding the debian/rules hunks etc.,
the correct patch becomes:

diff -ur e2fsprogs-1.39+1.40-WIP-2006.11.14+dfsg/lib/blkid/devname.c e2fsprogs-patched/lib/blkid/devname.c
--- e2fsprogs-1.39+1.40-WIP-2006.11.14+dfsg/lib/blkid/devname.c	2006-09-12 07:25:40.000000000 +0200
+++ e2fsprogs-patched/lib/blkid/devname.c	2007-03-06 14:00:03.000000000 +0100
@@ -305,6 +305,7 @@
 		probe_one(cache, device, dev, BLKID_PRI_DM, only_if_new);
 
 try_next:
+		free(device);
 		next = names->next;
 	} while (next);
 
diff -ur e2fsprogs-1.39+1.40-WIP-2006.11.14+dfsg/lib/blkid/probe.c e2fsprogs-patched/lib/blkid/probe.c
--- e2fsprogs-1.39+1.40-WIP-2006.11.14+dfsg/lib/blkid/probe.c	2006-09-18 03:12:28.000000000 +0200
+++ e2fsprogs-patched/lib/blkid/probe.c	2007-03-06 13:55:19.000000000 +0100
@@ -888,6 +888,10 @@
 	if (!dev->bid_type) {
 		if (probe.fd >= 0) close(probe.fd);
 		blkid_free_dev(dev);
+		if (probe.sbbuf)
+			free(probe.sbbuf);
+		if (probe.buf)
+			free(probe.buf);
 		return NULL;
 	}
 		
/* Steinar */
-- 
Homepage: http://www.sesse.net/



Information forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#413661; Package libblkid1. Full text and rfc822 format available.

Acknowledgement sent to Theodore Tso <tytso@mit.edu>:
Extra info received and forwarded to list. Copy sent to tytso@mit.edu (Theodore Y. Ts'o). Full text and rfc822 format available.

Message #17 received at 413661@bugs.debian.org (full text, mbox):

From: Theodore Tso <tytso@mit.edu>
To: "Steinar H. Gunderson" <sgunderson@bigfoot.com>, 413661@bugs.debian.org
Cc: debian-release@lists.debian.org
Subject: Re: Bug#413661: libblkid1: leaks memory like crazy
Date: Tue, 6 Mar 2007 10:44:55 -0500
On Tue, Mar 06, 2007 at 02:08:43PM +0100, Steinar H. Gunderson wrote:
> Package: libblkid1
> Version: 1.39+1.40-WIP-2006.11.14+dfsg-1
> Severity: grave
> Tags: patch
> 
> (RMs: I'm unsure if this should be fixed for etch or not, given that I
> do not know of anything in etch that actually uses this library enough
> for it to leak. Feel free to downgrade or tag etch-ignore, of course.)
> 
> nfs-kernel-server 1.0.12 has started using libblkid, and leaks absurd
> amounts of memory (in the order of several megabytes per minute).
> Tracing using Omega (which is not yet in Debian, but nevertheless really
> useful) tracked the leaks down to libblkid. I've attached a diff that
> fixes the issues for me, and allows me to run nfs-kernel-server with
> only minor leaks (which I'll take with nfs-utils upstream, as they are
> not libblkid1 related).

Yikes, what blkid function is rpc.mountd calling all the time which is
causing this kind of memory leakage?  Sounds like a bad thing from a
power/CPU utilization standpoint (note to self; shut down rpc.mountd
when I'm running on batteries on my laptop).  I'm also curious why we
only discovered the problem this late in the freeze....

Oh, I see, because nfs-kernel-server 1.0.10 is in testing, and 1.0.12
is in unstable.  I assume it's unlikely that nfs-kernel-server 1.0.12
is going to migrate to testing?

OK, release managers, the memory leak primarily occurs in the device
mapper probing code, and an additional leak when there is a partition
which does not have a valid filesystem known to blkid.  rpc.mountd is,
as far as I know, the first long-lived daemon using blkid, and it's
apparently using it in a somewhat "interesting" way which is the
system to constantly reprobe the disk information (if it is leaking
megabytes per minute).  The patch looks reasonably sane and low risk
based on a on-paper examination of the code changes --- but if
nfs-kernel-server 1.0.12 isn't going into etch, I'd say it's
borderline whether or not we include this patch into the e2fsprogs
upload I was about to do.

What say ye?

					- Ted

P.S.  I really want to look at the sources of nfs-kernel-server 1.0.12
and see what it's *doing* that could be provoking a memory leak of the
rate that you are describing.  The memory leak is clearly blkid's
fault, but the rate at which memory is leaking smells very fishy.




Information forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#413661; Package libblkid1. Full text and rfc822 format available.

Acknowledgement sent to "Steinar H. Gunderson" <sgunderson@bigfoot.com>:
Extra info received and forwarded to list. Copy sent to tytso@mit.edu (Theodore Y. Ts'o). Full text and rfc822 format available.

Message #22 received at 413661@bugs.debian.org (full text, mbox):

From: "Steinar H. Gunderson" <sgunderson@bigfoot.com>
To: Theodore Tso <tytso@mit.edu>
Cc: 413661@bugs.debian.org, debian-release@lists.debian.org
Subject: Re: Bug#413661: libblkid1: leaks memory like crazy
Date: Tue, 6 Mar 2007 16:54:41 +0100
On Tue, Mar 06, 2007 at 10:44:55AM -0500, Theodore Tso wrote:
> Yikes, what blkid function is rpc.mountd calling all the time which is
> causing this kind of memory leakage?

blkid_probe_all_new() seems to be the one. It happens at every mount and
umount, I believe; it's not like it's being called all the time (it leaks
much faster on busy systems than on almost idle systems, AFAICS), it's that
it leaks so _much_ memory all the time.

> Oh, I see, because nfs-kernel-server 1.0.10 is in testing, and 1.0.12
> is in unstable.  I assume it's unlikely that nfs-kernel-server 1.0.12
> is going to migrate to testing?

I was originally planning to ask for an exception (with associated RM bribes,
the diff is quite large), but given 1.0.11's and 1.0.12's track record so
far, I think that's quite far-fetched, yes.

> OK, release managers, the memory leak primarily occurs in the device
> mapper probing code, and an additional leak when there is a partition
> which does not have a valid filesystem known to blkid.  rpc.mountd is,
> as far as I know, the first long-lived daemon using blkid, and it's
> apparently using it in a somewhat "interesting" way which is the
> system to constantly reprobe the disk information (if it is leaking
> megabytes per minute).  The patch looks reasonably sane and low risk
> based on a on-paper examination of the code changes --- but if
> nfs-kernel-server 1.0.12 isn't going into etch, I'd say it's
> borderline whether or not we include this patch into the e2fsprogs
> upload I was about to do.

FWIW, I agree with this analysis, possibly except the part about mountd's
usage pattern. :-)

/* Steinar */
-- 
Homepage: http://www.sesse.net/



Information forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#413661; Package libblkid1. Full text and rfc822 format available.

Acknowledgement sent to Theodore Tso <tytso@mit.edu>:
Extra info received and forwarded to list. Copy sent to tytso@mit.edu (Theodore Y. Ts'o). Full text and rfc822 format available.

Message #27 received at 413661@bugs.debian.org (full text, mbox):

From: Theodore Tso <tytso@mit.edu>
To: 413661@bugs.debian.org, debian-release@lists.debian.org
Subject: Re: Bug#413661: libblkid1: leaks memory like crazy
Date: Tue, 6 Mar 2007 11:42:16 -0500
On Tue, Mar 06, 2007 at 04:54:41PM +0100, Steinar H. Gunderson wrote:
> On Tue, Mar 06, 2007 at 10:44:55AM -0500, Theodore Tso wrote:
> > Yikes, what blkid function is rpc.mountd calling all the time which is
> > causing this kind of memory leakage?
> 
> blkid_probe_all_new() seems to be the one. It happens at every mount and
> umount, I believe; it's not like it's being called all the time (it leaks
> much faster on busy systems than on almost idle systems, AFAICS), it's that
> it leaks so _much_ memory all the time.

Well, the amount of memory leaked depends on how many device mapper
volumes you have, and how many of them contain unitialized volumes.
And I guess this must have been on a system with a lot of mounts and
unmounts.

						- Ted



Information forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#413661; Package libblkid1. Full text and rfc822 format available.

Acknowledgement sent to Steve Langasek <vorlon@debian.org>:
Extra info received and forwarded to list. Copy sent to tytso@mit.edu (Theodore Y. Ts'o). Full text and rfc822 format available.

Message #32 received at 413661@bugs.debian.org (full text, mbox):

From: Steve Langasek <vorlon@debian.org>
To: "Steinar H. Gunderson" <sgunderson@bigfoot.com>, 413661@bugs.debian.org
Subject: Re: Bug#413661: libblkid1: leaks memory like crazy
Date: Tue, 6 Mar 2007 14:00:34 -0800
severity 413661 important
thanks

On Tue, Mar 06, 2007 at 02:08:43PM +0100, Steinar H. Gunderson wrote:
> (RMs: I'm unsure if this should be fixed for etch or not, given that I
> do not know of anything in etch that actually uses this library enough
> for it to leak. Feel free to downgrade or tag etch-ignore, of course.)

Indeed, nfs-kernel-server in unstable is the only daemon using the lib;
all the other reverse-deps are short-lived utils.

So, downgrading.

-- 
Steve Langasek                   Give me a lever long enough and a Free OS
Debian Developer                   to set it on, and I can move the world.
vorlon@debian.org                                   http://www.debian.org/



Severity set to `important' from `grave' Request was from Steve Langasek <vorlon@debian.org> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#413661; Package libblkid1. Full text and rfc822 format available.

Acknowledgement sent to Steve Langasek <vorlon@debian.org>:
Extra info received and forwarded to list. Copy sent to tytso@mit.edu (Theodore Y. Ts'o). Full text and rfc822 format available.

Message #39 received at 413661@bugs.debian.org (full text, mbox):

From: Steve Langasek <vorlon@debian.org>
To: Theodore Tso <tytso@mit.edu>
Cc: "Steinar H. Gunderson" <sgunderson@bigfoot.com>, 413661@bugs.debian.org, debian-release@lists.debian.org
Subject: Re: Bug#413661: libblkid1: leaks memory like crazy
Date: Tue, 6 Mar 2007 14:05:38 -0800
On Tue, Mar 06, 2007 at 10:44:55AM -0500, Theodore Tso wrote:

> OK, release managers, the memory leak primarily occurs in the device
> mapper probing code, and an additional leak when there is a partition
> which does not have a valid filesystem known to blkid.  rpc.mountd is,
> as far as I know, the first long-lived daemon using blkid, and it's
> apparently using it in a somewhat "interesting" way which is the
> system to constantly reprobe the disk information (if it is leaking
> megabytes per minute).  The patch looks reasonably sane and low risk
> based on a on-paper examination of the code changes --- but if
> nfs-kernel-server 1.0.12 isn't going into etch, I'd say it's
> borderline whether or not we include this patch into the e2fsprogs
> upload I was about to do.

No strong opinion either way; I'm more concerned that the e2fsprogs upload
happens sooner rather than later, so that d-i RC2 doesn't get held up
waiting for it.

Thanks,
-- 
Steve Langasek                   Give me a lever long enough and a Free OS
Debian Developer                   to set it on, and I can move the world.
vorlon@debian.org                                   http://www.debian.org/



Information forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#413661; Package libblkid1. Full text and rfc822 format available.

Acknowledgement sent to Theodore Tso <tytso@mit.edu>:
Extra info received and forwarded to list. Copy sent to tytso@mit.edu (Theodore Y. Ts'o). Full text and rfc822 format available.

Message #44 received at 413661@bugs.debian.org (full text, mbox):

From: Theodore Tso <tytso@mit.edu>
To: "Steinar H. Gunderson" <sgunderson@bigfoot.com>, 413661@bugs.debian.org, debian-release@lists.debian.org
Subject: Re: Bug#413661: libblkid1: leaks memory like crazy
Date: Tue, 6 Mar 2007 21:36:00 -0500
On Tue, Mar 06, 2007 at 02:05:38PM -0800, Steve Langasek wrote:
> No strong opinion either way; I'm more concerned that the e2fsprogs upload
> happens sooner rather than later, so that d-i RC2 doesn't get held up
> waiting for it.

I'm uploading it now to unstable.

Thanks,

						- Ted



Reply sent to tytso@mit.edu (Theodore Y. Ts'o):
You have taken responsibility. Full text and rfc822 format available.

Notification sent to "Steinar H. Gunderson" <sgunderson@bigfoot.com>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #49 received at 413661-close@bugs.debian.org (full text, mbox):

From: tytso@mit.edu (Theodore Y. Ts'o)
To: 413661-close@bugs.debian.org
Subject: Bug#413661: fixed in e2fsprogs 1.39+1.40-WIP-2006.11.14+dfsg-2
Date: Wed, 07 Mar 2007 02:47:03 +0000
Source: e2fsprogs
Source-Version: 1.39+1.40-WIP-2006.11.14+dfsg-2

We believe that the bug you reported is fixed in the latest version of
e2fsprogs, which is due to be installed in the Debian FTP archive:

comerr-dev_2.1-1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
  to pool/main/e/e2fsprogs/comerr-dev_2.1-1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
e2fsck-static_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
  to pool/main/e/e2fsprogs/e2fsck-static_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
e2fslibs-dev_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
  to pool/main/e/e2fsprogs/e2fslibs-dev_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
e2fslibs_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
  to pool/main/e/e2fsprogs/e2fslibs_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
e2fsprogs-udeb_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.udeb
  to pool/main/e/e2fsprogs/e2fsprogs-udeb_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.udeb
e2fsprogs_1.39+1.40-WIP-2006.11.14+dfsg-2.diff.gz
  to pool/main/e/e2fsprogs/e2fsprogs_1.39+1.40-WIP-2006.11.14+dfsg-2.diff.gz
e2fsprogs_1.39+1.40-WIP-2006.11.14+dfsg-2.dsc
  to pool/main/e/e2fsprogs/e2fsprogs_1.39+1.40-WIP-2006.11.14+dfsg-2.dsc
e2fsprogs_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
  to pool/main/e/e2fsprogs/e2fsprogs_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
libblkid-dev_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
  to pool/main/e/e2fsprogs/libblkid-dev_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
libblkid1-udeb_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.udeb
  to pool/main/e/e2fsprogs/libblkid1-udeb_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.udeb
libblkid1_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
  to pool/main/e/e2fsprogs/libblkid1_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
libcomerr2_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
  to pool/main/e/e2fsprogs/libcomerr2_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
libss2_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
  to pool/main/e/e2fsprogs/libss2_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
libuuid1-udeb_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.udeb
  to pool/main/e/e2fsprogs/libuuid1-udeb_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.udeb
libuuid1_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
  to pool/main/e/e2fsprogs/libuuid1_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
ss-dev_2.0-1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
  to pool/main/e/e2fsprogs/ss-dev_2.0-1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
uuid-dev_1.2-1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
  to pool/main/e/e2fsprogs/uuid-dev_1.2-1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 413661@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Theodore Y. Ts'o <tytso@mit.edu> (supplier of updated e2fsprogs package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Tue,  6 Mar 2007 18:27:21 -0700
Source: e2fsprogs
Binary: e2fslibs-dev libblkid1-udeb libblkid1 comerr-dev libuuid1 ss-dev uuid-dev e2fslibs e2fsck-static e2fsprogs-udeb libuuid1-udeb e2fsprogs libblkid-dev libcomerr2 libss2
Architecture: source i386
Version: 1.39+1.40-WIP-2006.11.14+dfsg-2
Distribution: unstable
Urgency: high
Maintainer: Theodore Y. Ts'o <tytso@mit.edu>
Changed-By: Theodore Y. Ts'o <tytso@mit.edu>
Description: 
 comerr-dev - common error description library - headers and static libraries
 e2fsck-static - statically-linked version of the ext2 filesystem checker
 e2fslibs   - ext2 filesystem libraries
 e2fslibs-dev - ext2 filesystem libraries - headers and static libraries
 e2fsprogs  - ext2 file system utilities and libraries
 e2fsprogs-udeb - stripped-down versions of e2fsprogs, for debian-installer (udeb)
 libblkid-dev - block device id library - headers and static libraries
 libblkid1  - block device id library
 libblkid1-udeb - block device id library (udeb)
 libcomerr2 - common error description library
 libss2     - command-line interface parsing library
 libuuid1   - universally unique id library
 libuuid1-udeb - universally unique id library (udeb)
 ss-dev     - command-line interface parsing library - headers and static libra
 uuid-dev   - universally unique id library - headers and static libraries
Closes: 413208 413661
Changes: 
 e2fsprogs (1.39+1.40-WIP-2006.11.14+dfsg-2) unstable; urgency=high
 .
   * Fix memory leak in blkid library.  (Closes: #413661)
   * Add a versioned dependency to blkid's shlibs file to avoid upgrade
     problems to programs like nfs-kernel-server which depend on blkid.
     (Closes: #413208)
   * Set urgency level to high to allow migration in time for d-i images,
     per request from Frans Pop.
Files: 
 9e66e34e6f03da7207563fc5be7b85cd 901 admin required e2fsprogs_1.39+1.40-WIP-2006.11.14+dfsg-2.dsc
 c213ba32f4c66670d18a4e79e2a8082d 1032 admin required e2fsprogs_1.39+1.40-WIP-2006.11.14+dfsg-2.diff.gz
 826f6e9d04a5c1f34e9bb16937cbe339 493298 admin optional e2fsck-static_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
 5005e236a4875145bde7d8aa34aa9855 31114 libs required libcomerr2_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
 ffee55cef56abdf47eae847e12671d35 37158 libs required libss2_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
 748fcd37c8934c77740701488310da46 33418 libs required libuuid1_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
 0bd88261ee93034e331edc799a471eb1 43370 libs required libblkid1_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
 8ad6b5e82fdc0012130444b1daeb4790 64844 libdevel extra libblkid-dev_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
 ffec56c14a80af26c822094b8cbeedde 86822 libs required e2fslibs_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
 bc97db6977459d2a4da267723678fd4a 423250 libdevel extra e2fslibs-dev_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
 25bf2bcac6b6c92df26ff76d565b5bc7 596094 admin required e2fsprogs_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
 9aca695dd1aae680fc0d37cfaa5bd3cb 46278 libdevel extra comerr-dev_2.1-1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
 615070ebd388dc3ae4b9fe10f81c35f2 42282 libdevel extra ss-dev_2.0-1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
 411ae0b16fce600546ae6cb00933b2aa 57552 libdevel extra uuid-dev_1.2-1.39+1.40-WIP-2006.11.14+dfsg-2_i386.deb
 ea9a601c2be2c0a04e56854de01cec81 158952 debian-installer optional e2fsprogs-udeb_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.udeb
 e62eb8947f163a1f7d719a695a64c946 14162 debian-installer optional libblkid1-udeb_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.udeb
 a5a8c1e9ac18535546a90bf2d9ffe273 5392 debian-installer optional libuuid1-udeb_1.39+1.40-WIP-2006.11.14+dfsg-2_i386.udeb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.6 (GNU/Linux)

iD8DBQFF7iGp7To545NnTEARAvcYAKCIeTcAU0o/WGbki3CaCLB/mM5eQACfat75
lK+CILrTUiyBugsRePI3RG0=
=73Aq
-----END PGP SIGNATURE-----




Information forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#413661; Package libblkid1. Full text and rfc822 format available.

Acknowledgement sent to Philip Armstrong <phil@kantaka.co.uk>:
Extra info received and forwarded to list. Copy sent to tytso@mit.edu (Theodore Y. Ts'o). Full text and rfc822 format available.

Message #54 received at 413661@bugs.debian.org (full text, mbox):

From: Philip Armstrong <phil@kantaka.co.uk>
To: "Steinar H. Gunderson" <sgunderson@bigfoot.com>
Cc: 413661@bugs.debian.org
Subject: Re: libblkid1: leaks memory like crazy
Date: Wed, 7 Mar 2007 09:59:19 +0000
On Tue, Mar 06, 2007 at 04:19:43PM +0100, Steinar H. Gunderson wrote:
>diff -ur e2fsprogs-1.39+1.40-WIP-2006.11.14+dfsg/lib/blkid/probe.c e2fsprogs-patched/lib/blkid/probe.c
>--- e2fsprogs-1.39+1.40-WIP-2006.11.14+dfsg/lib/blkid/probe.c	2006-09-18 03:12:28.000000000 +0200
>+++ e2fsprogs-patched/lib/blkid/probe.c	2007-03-06 13:55:19.000000000 +0100
>@@ -888,6 +888,10 @@
> 	if (!dev->bid_type) {
> 		if (probe.fd >= 0) close(probe.fd);
> 		blkid_free_dev(dev);
>+		if (probe.sbbuf)
>+			free(probe.sbbuf);
>+		if (probe.buf)
>+			free(probe.buf);
> 		return NULL;
> 	}

Those if(probe.thingy) guards are entirely redundant: free(p) is a
no-op if p is NULL.

Phil

-- 
http://www.kantaka.co.uk/ .oOo. public key: http://www.kantaka.co.uk/gpg.txt



Information forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#413661; Package libblkid1. Full text and rfc822 format available.

Acknowledgement sent to Theodore Tso <tytso@mit.edu>:
Extra info received and forwarded to list. Copy sent to tytso@mit.edu (Theodore Y. Ts'o). Full text and rfc822 format available.

Message #59 received at 413661@bugs.debian.org (full text, mbox):

From: Theodore Tso <tytso@mit.edu>
To: Philip Armstrong <phil@kantaka.co.uk>, 413661@bugs.debian.org
Cc: "Steinar H. Gunderson" <sgunderson@bigfoot.com>
Subject: Re: Bug#413661: libblkid1: leaks memory like crazy
Date: Wed, 7 Mar 2007 07:52:24 -0500
On Wed, Mar 07, 2007 at 09:59:19AM +0000, Philip Armstrong wrote:
> 
> Those if(probe.thingy) guards are entirely redundant: free(p) is a
> no-op if p is NULL.

I didn't use that particular patch, but one that uses a goto into the
standard function exit/cleanup path.  

However, e2fsprogs is still mostly written in a pre-C99 style, because
there are systems where free() will fail or crash if passed the NULL
pointer.  (I'll note that the gdb coding standards still requires the
use of xfree(), which does the null pointer check because of this
concession to pragmatics.)  So Steinar simply wrote the patch in the
style of the surrounding code, which is a Good Thing.

Regards,

					- Ted



Information forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#413661; Package libblkid1. Full text and rfc822 format available.

Acknowledgement sent to Philip Armstrong <phil@kantaka.co.uk>:
Extra info received and forwarded to list. Copy sent to tytso@mit.edu (Theodore Y. Ts'o). Full text and rfc822 format available.

Message #64 received at 413661@bugs.debian.org (full text, mbox):

From: Philip Armstrong <phil@kantaka.co.uk>
To: Theodore Tso <tytso@mit.edu>
Cc: 413661@bugs.debian.org, "Steinar H. Gunderson" <sgunderson@bigfoot.com>
Subject: Re: Bug#413661: libblkid1: leaks memory like crazy
Date: Wed, 7 Mar 2007 13:05:14 +0000
On Wed, Mar 07, 2007 at 07:52:24AM -0500, Theodore Tso wrote:
>On Wed, Mar 07, 2007 at 09:59:19AM +0000, Philip Armstrong wrote:
>> 
>> Those if(probe.thingy) guards are entirely redundant: free(p) is a
>> no-op if p is NULL.
>
>I didn't use that particular patch, but one that uses a goto into the
>standard function exit/cleanup path.  
>
>However, e2fsprogs is still mostly written in a pre-C99 style, because
>there are systems where free() will fail or crash if passed the NULL
>pointer.  (I'll note that the gdb coding standards still requires the
>use of xfree(), which does the null pointer check because of this
>concession to pragmatics.)  So Steinar simply wrote the patch in the
>style of the surrounding code, which is a Good Thing.

Argh. (Point taken on the style issue though.)

Phil

ps: Wasn't free(NULL) supposed to be OK in C*89* ?? <googles> Ah yes,
the Rationale specifically mentions it: "The null pointer is specified
as a valid argument to this function to reduce the need for
special-case coding." The real world beats 18 year old standard every
time of course, but are there really actual systems still around
(which e2fsprogs is expected to run on) that crash on free(NULL) ? A
bit depressing if so...

-- 
http://www.kantaka.co.uk/ .oOo. public key: http://www.kantaka.co.uk/gpg.txt



Information forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#413661; Package libblkid1. Full text and rfc822 format available.

Acknowledgement sent to Steve Langasek <vorlon@debian.org>:
Extra info received and forwarded to list. Copy sent to tytso@mit.edu (Theodore Y. Ts'o). Full text and rfc822 format available.

Message #69 received at 413661@bugs.debian.org (full text, mbox):

From: Steve Langasek <vorlon@debian.org>
To: Theodore Tso <tytso@mit.edu>
Cc: "Steinar H. Gunderson" <sgunderson@bigfoot.com>, 413661@bugs.debian.org, debian-release@lists.debian.org
Subject: Re: Bug#413661: libblkid1: leaks memory like crazy
Date: Wed, 7 Mar 2007 15:00:56 -0800
On Tue, Mar 06, 2007 at 09:36:00PM -0500, Theodore Tso wrote:
> On Tue, Mar 06, 2007 at 02:05:38PM -0800, Steve Langasek wrote:
> > No strong opinion either way; I'm more concerned that the e2fsprogs upload
> > happens sooner rather than later, so that d-i RC2 doesn't get held up
> > waiting for it.

> I'm uploading it now to unstable.

And unblocked.

Thanks,
-- 
Steve Langasek                   Give me a lever long enough and a Free OS
Debian Developer                   to set it on, and I can move the world.
vorlon@debian.org                                   http://www.debian.org/



Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Tue, 26 Jun 2007 03:53:00 GMT) Full text and rfc822 format available.

Bug unarchived. Request was from Marcus Better <marcus@better.se> to control@bugs.debian.org. (Thu, 05 Jul 2007 19:48:02 GMT) Full text and rfc822 format available.

Bug marked as found in version e2fsprogs/1.39+1.40-wip-2006.11.14+dfsg-1. Request was from Marcus Better <marcus@better.se> to control@bugs.debian.org. (Fri, 06 Jul 2007 05:30:02 GMT) Full text and rfc822 format available.

Bug marked as not found in version 1.39+1.40-wip-2006.11.14+dfsg-1. Request was from Marcus Better <marcus@better.se> to control@bugs.debian.org. (Fri, 06 Jul 2007 05:30:02 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#413661; Package libblkid1. Full text and rfc822 format available.

Acknowledgement sent to Marcus Better <marcus@better.se>:
Extra info received and forwarded to list. Copy sent to tytso@mit.edu (Theodore Y. Ts'o). Full text and rfc822 format available.

Message #82 received at 413661@bugs.debian.org (full text, mbox):

From: Marcus Better <marcus@better.se>
To: 413661@bugs.debian.org
Cc: control@bugs.debian.org
Subject: rpc.mountd eats CPU, issues tons of ioctls
Date: Fri, 6 Jul 2007 07:46:41 +0200
[Message part 1 (text/plain, inline)]
clone 413661 -1
reassign -1 nfs-kernel-server
found -1 1:1.1.0-4
retitle -1 rpc.mountd eats CPU, issues tons of ioctls
found 413661 e2fsprogs/1.39+1.40-wip-2006.11.14+dfsg-1
thanks

rpc.mountd on my NFS server stalls for several minutes at the first mount 
attempt from the client. During this time, "top" shows mountd eating some 90% 
of the CPU time. After a while it calms down, the mount succeeds and 
everything works. strace shows that mountd is issuing lots of ioctls during 
this time (over 20k calls in a minute or so).

The system is a Linksys NSLU2 running Debian etch (arm), nfs-kernel-server 
1.1.0-4, Debian kernel 2.6.21-1-ixp4xx. The configuration is NFSv4 with 
Kerberos authentication.

Upstream suggested [1] that this was related to #413661, so I'm cloning the 
bug.

I have about the same setup on other i386 servers where I didn't notice this 
behaviour. That may be because the NSLU2 is so slow.

Attached is a part of the strace output.

Regards,

Marcus
[rpc.mountd.strace (text/plain, attachment)]
[signature.asc (application/pgp-signature, inline)]

Bug 413661 cloned as bug 431940. Request was from Marcus Better <marcus@better.se> to control@bugs.debian.org. (Fri, 06 Jul 2007 05:48:02 GMT) Full text and rfc822 format available.

Bug marked as found in version e2fsprogs/1.39+1.40-wip-2006.11.14+dfsg-1. Request was from Marcus Better <marcus@better.se> to control@bugs.debian.org. (Fri, 06 Jul 2007 06:36:07 GMT) Full text and rfc822 format available.

Bug marked as not found in version 1.39+1.40-wip-2006.11.14+dfsg-1. Request was from Don Armstrong <don@donarmstrong.com> to control@bugs.debian.org. (Fri, 06 Jul 2007 19:36:06 GMT) Full text and rfc822 format available.

Bug marked as found in version 1.39+1.40-WIP-2006.11.14+dfsg-1. Request was from Don Armstrong <don@donarmstrong.com> to control@bugs.debian.org. (Fri, 06 Jul 2007 19:36:07 GMT) Full text and rfc822 format available.

Bug marked as not fixed in version 1.39+1.40-wip-2006.11.14+dfsg-2. Request was from Don Armstrong <don@donarmstrong.com> to control@bugs.debian.org. (Fri, 06 Jul 2007 19:36:07 GMT) Full text and rfc822 format available.

Bug marked as fixed in version 1.39+1.40-WIP-2006.11.14+dfsg-2. Request was from Don Armstrong <don@donarmstrong.com> to control@bugs.debian.org. (Fri, 06 Jul 2007 19:36:08 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#413661; Package libblkid1. Full text and rfc822 format available.

Acknowledgement sent to "Steinar H. Gunderson" <sgunderson@bigfoot.com>:
Extra info received and forwarded to list. Copy sent to tytso@mit.edu (Theodore Y. Ts'o). Full text and rfc822 format available.

Message #99 received at 413661@bugs.debian.org (full text, mbox):

From: "Steinar H. Gunderson" <sgunderson@bigfoot.com>
To: Marcus Better <marcus@better.se>, 413661@bugs.debian.org
Subject: Re: Bug#413661: rpc.mountd eats CPU, issues tons of ioctls
Date: Sun, 8 Jul 2007 21:20:31 +0200
On Fri, Jul 06, 2007 at 07:46:41AM +0200, Marcus Better wrote:
> rpc.mountd on my NFS server stalls for several minutes at the first mount 
> attempt from the client. During this time, "top" shows mountd eating some 90% 
> of the CPU time. After a while it calms down, the mount succeeds and 
> everything works. strace shows that mountd is issuing lots of ioctls during 
> this time (over 20k calls in a minute or so).

I'm a bit confused here. You cloned the bug and reassigned one part against
nfs-utils -- this would usually indicate you mean _both_ nfs-utils and
e2fsprogs are buggy. Could you please retest with updated libblkid1, as I see
the bug has been closed by an upload on that side?

/* Steinar */
-- 
Homepage: http://www.sesse.net/



Information forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#413661; Package libblkid1. Full text and rfc822 format available.

Acknowledgement sent to Marcus Better <marcus@better.se>:
Extra info received and forwarded to list. Copy sent to tytso@mit.edu (Theodore Y. Ts'o). Full text and rfc822 format available.

Message #104 received at 413661@bugs.debian.org (full text, mbox):

From: Marcus Better <marcus@better.se>
To: "Steinar H. Gunderson" <sgunderson@bigfoot.com>
Cc: 413661@bugs.debian.org
Subject: Re: Bug#413661: rpc.mountd eats CPU, issues tons of ioctls
Date: Sun, 8 Jul 2007 21:38:42 +0200
[Message part 1 (text/plain, inline)]
Hi,

> I'm a bit confused here. You cloned the bug and reassigned one part against
> nfs-utils -- this would usually indicate you mean _both_ nfs-utils and
> e2fsprogs are buggy.

I should have explained my intentions better. I have problems with nfs-utils 
as described. A hint from upstream made me suspect that the discussion [2] 
has relevance for this bug.

My *guess* is that [2] describes the bug in rpc.mountd that causes this 
problem.

> Could you please retest with updated libblkid1, as I 
> see the bug has been closed by an upload on that side?

I am using libblkid1 1.39+1.40-WIP-2006.11.14+dfsg-2, so that bug is supposed 
to be fixed.

Marcus

[1] http://permalink.gmane.org/gmane.linux.nfsv4/5456
[2] http://bugs.debian.org/cgi-bin/bugreport.cgi?msg=17;bug=413661
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#413661; Package libblkid1. Full text and rfc822 format available.

Acknowledgement sent to Theodore Tso <tytso@mit.edu>:
Extra info received and forwarded to list. Copy sent to tytso@mit.edu (Theodore Y. Ts'o). Full text and rfc822 format available.

Message #109 received at 413661@bugs.debian.org (full text, mbox):

From: Theodore Tso <tytso@mit.edu>
To: Marcus Better <marcus@better.se>, 413661@bugs.debian.org
Cc: "Steinar H. Gunderson" <sgunderson@bigfoot.com>
Subject: Re: Bug#413661: rpc.mountd eats CPU, issues tons of ioctls
Date: Sun, 8 Jul 2007 18:32:06 -0400
On Sun, Jul 08, 2007 at 09:38:42PM +0200, Marcus Better wrote:
> Hi,
> 
> > I'm a bit confused here. You cloned the bug and reassigned one part against
> > nfs-utils -- this would usually indicate you mean _both_ nfs-utils and
> > e2fsprogs are buggy.
> 
> I should have explained my intentions better. I have problems with nfs-utils 
> as described. A hint from upstream made me suspect that the discussion [2] 
> has relevance for this bug.
> 
> My *guess* is that [2] describes the bug in rpc.mountd that causes this 
> problem.

The two bugs are not related at all.  Bug #413661 is a memory leak.
It causes rpc.mountd to use more and more memory over time; and it
wasn't detected right away since most users of blkid do their thing
and then exit; they aren't a long-term daemon.  that bug was fixed in
e2fsprogs version 1.39+1.40-WIP-2007.04.07+dfsg-1.   

You are looking at a bug that involves lots and lots of calls to
ioctl(), and that's clearly something else.

OK, so could you please do the following and then open a new bug
against libblkid1, if you are sure the fault lies there.  Save a copy
of /etc/blkid.tab first (cp /etc/blkid.tab /tmp/blkid.tab.1).  Next,
set the environment variable BLKID_DEBUG to the value 0xffff ("export
BLKID_DEBUG=0xffff") and then run rpc.mountd in the foreground with
the output redirected to a file (rpc.mountd -F > /tmp/mountd.log);
make sure you kill off the rpc.mound which is running as a daemon
first.  Finally save another a copy of /etc/blkid.tab (cp
/etc/blkid.tab /tmp/blkid.tab.2)

Now trigger a mount request, and check to see that you see blkid debug
messages showing up in /tmp/mountd.log.  Then send me (via the new bug
report) the /tmp/mountd.log, /tmp/blkid.tab.1, and /tmp/blkid.tab.2
files.

Thanks!

						- Ted

P.S.  In the future, unless you're absolutely certain that a bug you
are seeing is related, please don't claim a bug is found.  There is a
rather large difference between a memory leak and lots of md ioctl's.



Bug marked as not found in version 1.39+1.40-WIP-2006.11.14+dfsg-1. Request was from "Theodore Ts'o" <tytso@mit.edu> to control@bugs.debian.org. (Sun, 08 Jul 2007 22:42:02 GMT) Full text and rfc822 format available.

Bug marked as fixed in version 1.39+1.40-WIP-2007.04.07+dfsg-1. Request was from "Theodore Ts'o" <tytso@mit.edu> to control@bugs.debian.org. (Sun, 08 Jul 2007 22:42:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, tytso@mit.edu (Theodore Y. Ts'o):
Bug#413661; Package libblkid1. Full text and rfc822 format available.

Acknowledgement sent to Marcus Better <marcus@better.se>:
Extra info received and forwarded to list. Copy sent to tytso@mit.edu (Theodore Y. Ts'o). Full text and rfc822 format available.

Message #118 received at 413661@bugs.debian.org (full text, mbox):

From: Marcus Better <marcus@better.se>
To: Theodore Tso <tytso@mit.edu>
Cc: 413661@bugs.debian.org, "Steinar H. Gunderson" <sgunderson@bigfoot.com>, 431940@bugs.debian.org, control@bugs.debian.org
Subject: Re: Bug#413661: rpc.mountd eats CPU, issues tons of ioctls
Date: Mon, 9 Jul 2007 15:40:37 +0200
[Message part 1 (text/plain, inline)]
reassign 431940 libblkid1
found 431940 1.39+1.40-WIP-2006.11.14+dfsg-2
notfound 431940 nfs-utils/1:1.1.0-4
unblock 413429 with 431940
thanks

> Now trigger a mount request, and check to see that you see blkid debug
> messages showing up in /tmp/mountd.log.

I don't see anything at all in mountd.log, although the mount hangs and the 
CPU is busy as before. The console shows the following:

mountd: /srv/nfs/home exported to both gss/krb5 and gss/krb5, arbitrarily 
choosing options from first
mountd: /srv/nfs/home and /srv/nfs/home have same filehandle for gss/krb5, 
using first
mountd: /srv/nfs/music exported to both gss/krb5 and gss/krb5, arbitrarily 
choosing options from first
mountd: /srv/nfs/music and /srv/nfs/music have same filehandle for gss/krb5, 
using first
mountd: /srv/nfs/photos exported to both gss/krb5 and gss/krb5, arbitrarily 
choosing options from first
mountd: /srv/nfs/photos and /srv/nfs/photos have same filehandle for gss/krb5, 
using first
mountd: /srv/nfs/contacts exported to both gss/krb5 and gss/krb5, arbitrarily 
choosing options from first

Not sure this has to do with the bug, since I only noticed these messages 
yesterday, and the bug has been present much longer.

~# cat /etc/exports
/srv/nfs                gss/krb5(rw,sync,fsid=0,crossmnt,no_subtree_check)
/srv/nfs/home           gss/krb5(rw,sync,insecure,no_subtree_check)
#/srv/nfs/media         gss/krb5(rw,sync,insecure,no_subtree_check)
/srv/nfs/music          gss/krb5(rw,sync,insecure,no_subtree_check)
/srv/nfs/photos         gss/krb5(rw,sync,insecure,no_subtree_check)
/srv/nfs/contacts       gss/krb5(rw,sync,insecure,no_subtree_check)

> Then send me (via the new bug 
> report) the /tmp/mountd.log, /tmp/blkid.tab.1, and /tmp/blkid.tab.2
> files.

Attached (except for empty mountd.log).

Thanks,

Marcus

PS. The "found" exercises were my attempt to fix the version graph for the bug 
which was wrong, as you have probably seen.
[blkid.tab.1 (text/plain, attachment)]
[blkid.tab.2 (text/plain, attachment)]
[signature.asc (application/pgp-signature, inline)]

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 09 Jan 2008 07:33:03 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 15:37:34 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.